//+------------------------------------------------------------------+
//|                                             VininI_XMA7.2.V1.mq4 |
//|                                          Copyright  2009, Vinin |
//|                                             http://vinin.ucoz.ru |
//-------------------------------------------------------------------+
#property copyright "Copyright  2009, Vinin"
#property link      "http://vinin.ucoz.ru"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Red


extern double  porog =1.0;
extern double  teil=0.01;


//---- buffers
double Signal0[];
double Signal1[];
#define SIGNAL_BAR 1
//+------------------------------------------------------------------+
void init(){
   IndicatorShortName("Xma("+DoubleToStr(porog,2)+")");

   SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexDrawBegin(0,0); 
   SetIndexBuffer(0,Signal0); 
   SetIndexLabel(0,"Signal 1");

   SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexDrawBegin(1,0); 
   SetIndexBuffer(1,Signal1); 
   SetIndexLabel(1,"Signal 2");

   if (teil<0) teil=0.00001;
   if (teil>1) teil=0.99999;   
   return;
} 
int deinit(){
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   Calc0(limit); 
   Calc3(limit); 
//     
//----  ,   
//----       
	static int PrevSignal = 0, PrevTime = 0;
//----       0-,     
//----  .     , .
	if(SIGNAL_BAR > 0 && Time[0] <= PrevTime) 
	return(0);
//---- ,    
	  PrevTime = Time[0];

//----          (PrevSignal=0)
	if(PrevSignal <= 0)
	    {
		     //---- ,       :
		     if(Signal0[SIGNAL_BAR] - Signal1[SIGNAL_BAR] > 0 && 
				      Signal1[SIGNAL_BAR+1] - Signal0[SIGNAL_BAR+1] >= 0)
		       {
			        //----  ,     - 
			        PrevSignal = 1;
			        //----   :
			        SendMail ("Xma (", Symbol(), ", ", Period(), ")  -  BUY!!!" ) ;
          
		       }
	    }
//----     
	  if(PrevSignal >= 0
	    {
		     if(Signal1[SIGNAL_BAR] - Signal0[SIGNAL_BAR] > 0 && 
				      Signal0[SIGNAL_BAR+1] - Signal1[SIGNAL_BAR+1] >= 0)
		       {
			        PrevSignal = -1;
			        SendMail ( "Xma (", Symbol(), ", ", Period(), ")  -  SELL!!!" );
          
		       }
	    }
//----	
   
   return(0);
}
//+------------------------------------------------------------------+   

int Sign(double a) {if (a>0) return(1); if (a<0) return(-1); return(0);}

void Calc0(int limit){
   double tmpCandle, Price;
   for (int i=limit;i>=0;i--) {
      tmpCandle=porog/1000.0*Close[i];
      if (Signal0[i+1]==0) { Signal0[i]=(High[i]+Low[i])/2.0;  continue; } 
      
      Signal0[i]=Signal0[i+1];

     
      Price=High[i];
      if (MathAbs(Low[i]-Signal0[i])>MathAbs(Price-Signal0[i])) Price=Low[i];
         
      if (MathAbs(Price-Signal0[i])>tmpCandle) {
         Signal0[i]=(Price*teil+(1.0-teil)*1000.0/(1000.0+Sign(Price-Signal0[i])*porog)*Price); 
      }
   }
   Comment("  =",tmpCandle);
}



void Calc3(int limit){
   double tmpCandle, Price;
   for (int i=limit;i>=0;i--) {
      tmpCandle=porog/1000.0*Close[i];
      if (Signal1[i+1]==0) { Signal1[i]=(High[i]+Low[i])/2.0;  continue; } 
      
      Signal1[i]=Signal1[i+1];

     
      Price=(High[i]+Low[i])/2.0;
         
      if (MathAbs(Price-Signal1[i])>tmpCandle) {
         Signal1[i]=Price*teil+Signal1[i]*(1-teil);
      }
   }
   Comment("  =",tmpCandle);
    
  }      
}